// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// RevenueGoal is an object representing the database table.
type RevenueGoal struct {
	ID        int64      `boil:"id" json:"id" toml:"id" yaml:"id"`
	Month     null.Int   `boil:"month" json:"month,omitempty" toml:"month" yaml:"month,omitempty"`
	Year      null.Int   `boil:"year" json:"year,omitempty" toml:"year" yaml:"year,omitempty"`
	Amount    null.Int64 `boil:"amount" json:"amount,omitempty" toml:"amount" yaml:"amount,omitempty"`
	CreatedAt time.Time  `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt time.Time  `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *revenueGoalR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L revenueGoalL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var RevenueGoalColumns = struct {
	ID        string
	Month     string
	Year      string
	Amount    string
	CreatedAt string
	UpdatedAt string
}{
	ID:        "id",
	Month:     "month",
	Year:      "year",
	Amount:    "amount",
	CreatedAt: "created_at",
	UpdatedAt: "updated_at",
}

var RevenueGoalTableColumns = struct {
	ID        string
	Month     string
	Year      string
	Amount    string
	CreatedAt string
	UpdatedAt string
}{
	ID:        "revenue_goal.id",
	Month:     "revenue_goal.month",
	Year:      "revenue_goal.year",
	Amount:    "revenue_goal.amount",
	CreatedAt: "revenue_goal.created_at",
	UpdatedAt: "revenue_goal.updated_at",
}

// Generated where

var RevenueGoalWhere = struct {
	ID        whereHelperint64
	Month     whereHelpernull_Int
	Year      whereHelpernull_Int
	Amount    whereHelpernull_Int64
	CreatedAt whereHelpertime_Time
	UpdatedAt whereHelpertime_Time
}{
	ID:        whereHelperint64{field: "\"revenue_goal\".\"id\""},
	Month:     whereHelpernull_Int{field: "\"revenue_goal\".\"month\""},
	Year:      whereHelpernull_Int{field: "\"revenue_goal\".\"year\""},
	Amount:    whereHelpernull_Int64{field: "\"revenue_goal\".\"amount\""},
	CreatedAt: whereHelpertime_Time{field: "\"revenue_goal\".\"created_at\""},
	UpdatedAt: whereHelpertime_Time{field: "\"revenue_goal\".\"updated_at\""},
}

// RevenueGoalRels is where relationship names are stored.
var RevenueGoalRels = struct {
}{}

// revenueGoalR is where relationships are stored.
type revenueGoalR struct {
}

// NewStruct creates a new relationship struct
func (*revenueGoalR) NewStruct() *revenueGoalR {
	return &revenueGoalR{}
}

// revenueGoalL is where Load methods for each relationship are stored.
type revenueGoalL struct{}

var (
	revenueGoalAllColumns            = []string{"id", "month", "year", "amount", "created_at", "updated_at"}
	revenueGoalColumnsWithoutDefault = []string{}
	revenueGoalColumnsWithDefault    = []string{"id", "month", "year", "amount", "created_at", "updated_at"}
	revenueGoalPrimaryKeyColumns     = []string{"id"}
	revenueGoalGeneratedColumns      = []string{}
)

type (
	// RevenueGoalSlice is an alias for a slice of pointers to RevenueGoal.
	// This should almost always be used instead of []RevenueGoal.
	RevenueGoalSlice []*RevenueGoal
	// RevenueGoalHook is the signature for custom RevenueGoal hook methods
	RevenueGoalHook func(context.Context, boil.ContextExecutor, *RevenueGoal) error

	revenueGoalQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	revenueGoalType                 = reflect.TypeOf(&RevenueGoal{})
	revenueGoalMapping              = queries.MakeStructMapping(revenueGoalType)
	revenueGoalPrimaryKeyMapping, _ = queries.BindMapping(revenueGoalType, revenueGoalMapping, revenueGoalPrimaryKeyColumns)
	revenueGoalInsertCacheMut       sync.RWMutex
	revenueGoalInsertCache          = make(map[string]insertCache)
	revenueGoalUpdateCacheMut       sync.RWMutex
	revenueGoalUpdateCache          = make(map[string]updateCache)
	revenueGoalUpsertCacheMut       sync.RWMutex
	revenueGoalUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var revenueGoalAfterSelectHooks []RevenueGoalHook

var revenueGoalBeforeInsertHooks []RevenueGoalHook
var revenueGoalAfterInsertHooks []RevenueGoalHook

var revenueGoalBeforeUpdateHooks []RevenueGoalHook
var revenueGoalAfterUpdateHooks []RevenueGoalHook

var revenueGoalBeforeDeleteHooks []RevenueGoalHook
var revenueGoalAfterDeleteHooks []RevenueGoalHook

var revenueGoalBeforeUpsertHooks []RevenueGoalHook
var revenueGoalAfterUpsertHooks []RevenueGoalHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *RevenueGoal) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *RevenueGoal) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *RevenueGoal) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *RevenueGoal) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *RevenueGoal) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *RevenueGoal) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *RevenueGoal) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *RevenueGoal) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *RevenueGoal) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range revenueGoalAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddRevenueGoalHook registers your hook function for all future operations.
func AddRevenueGoalHook(hookPoint boil.HookPoint, revenueGoalHook RevenueGoalHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		revenueGoalAfterSelectHooks = append(revenueGoalAfterSelectHooks, revenueGoalHook)
	case boil.BeforeInsertHook:
		revenueGoalBeforeInsertHooks = append(revenueGoalBeforeInsertHooks, revenueGoalHook)
	case boil.AfterInsertHook:
		revenueGoalAfterInsertHooks = append(revenueGoalAfterInsertHooks, revenueGoalHook)
	case boil.BeforeUpdateHook:
		revenueGoalBeforeUpdateHooks = append(revenueGoalBeforeUpdateHooks, revenueGoalHook)
	case boil.AfterUpdateHook:
		revenueGoalAfterUpdateHooks = append(revenueGoalAfterUpdateHooks, revenueGoalHook)
	case boil.BeforeDeleteHook:
		revenueGoalBeforeDeleteHooks = append(revenueGoalBeforeDeleteHooks, revenueGoalHook)
	case boil.AfterDeleteHook:
		revenueGoalAfterDeleteHooks = append(revenueGoalAfterDeleteHooks, revenueGoalHook)
	case boil.BeforeUpsertHook:
		revenueGoalBeforeUpsertHooks = append(revenueGoalBeforeUpsertHooks, revenueGoalHook)
	case boil.AfterUpsertHook:
		revenueGoalAfterUpsertHooks = append(revenueGoalAfterUpsertHooks, revenueGoalHook)
	}
}

// One returns a single revenueGoal record from the query.
func (q revenueGoalQuery) One(ctx context.Context, exec boil.ContextExecutor) (*RevenueGoal, error) {
	o := &RevenueGoal{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for revenue_goal")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all RevenueGoal records from the query.
func (q revenueGoalQuery) All(ctx context.Context, exec boil.ContextExecutor) (RevenueGoalSlice, error) {
	var o []*RevenueGoal

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to RevenueGoal slice")
	}

	if len(revenueGoalAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all RevenueGoal records in the query.
func (q revenueGoalQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count revenue_goal rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q revenueGoalQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if revenue_goal exists")
	}

	return count > 0, nil
}

// RevenueGoals retrieves all the records using an executor.
func RevenueGoals(mods ...qm.QueryMod) revenueGoalQuery {
	mods = append(mods, qm.From("\"revenue_goal\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"revenue_goal\".*"})
	}

	return revenueGoalQuery{q}
}

// FindRevenueGoal retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindRevenueGoal(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*RevenueGoal, error) {
	revenueGoalObj := &RevenueGoal{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"revenue_goal\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, revenueGoalObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from revenue_goal")
	}

	if err = revenueGoalObj.doAfterSelectHooks(ctx, exec); err != nil {
		return revenueGoalObj, err
	}

	return revenueGoalObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *RevenueGoal) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no revenue_goal provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(revenueGoalColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	revenueGoalInsertCacheMut.RLock()
	cache, cached := revenueGoalInsertCache[key]
	revenueGoalInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			revenueGoalAllColumns,
			revenueGoalColumnsWithDefault,
			revenueGoalColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(revenueGoalType, revenueGoalMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(revenueGoalType, revenueGoalMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"revenue_goal\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"revenue_goal\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into revenue_goal")
	}

	if !cached {
		revenueGoalInsertCacheMut.Lock()
		revenueGoalInsertCache[key] = cache
		revenueGoalInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the RevenueGoal.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *RevenueGoal) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	revenueGoalUpdateCacheMut.RLock()
	cache, cached := revenueGoalUpdateCache[key]
	revenueGoalUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			revenueGoalAllColumns,
			revenueGoalPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update revenue_goal, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"revenue_goal\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, revenueGoalPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(revenueGoalType, revenueGoalMapping, append(wl, revenueGoalPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update revenue_goal row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for revenue_goal")
	}

	if !cached {
		revenueGoalUpdateCacheMut.Lock()
		revenueGoalUpdateCache[key] = cache
		revenueGoalUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q revenueGoalQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for revenue_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for revenue_goal")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o RevenueGoalSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), revenueGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"revenue_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, revenueGoalPrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in revenueGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all revenueGoal")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *RevenueGoal) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no revenue_goal provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(revenueGoalColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	revenueGoalUpsertCacheMut.RLock()
	cache, cached := revenueGoalUpsertCache[key]
	revenueGoalUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			revenueGoalAllColumns,
			revenueGoalColumnsWithDefault,
			revenueGoalColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			revenueGoalAllColumns,
			revenueGoalPrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert revenue_goal, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(revenueGoalPrimaryKeyColumns))
			copy(conflict, revenueGoalPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"revenue_goal\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(revenueGoalType, revenueGoalMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(revenueGoalType, revenueGoalMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert revenue_goal")
	}

	if !cached {
		revenueGoalUpsertCacheMut.Lock()
		revenueGoalUpsertCache[key] = cache
		revenueGoalUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single RevenueGoal record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *RevenueGoal) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no RevenueGoal provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), revenueGoalPrimaryKeyMapping)
	sql := "DELETE FROM \"revenue_goal\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from revenue_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for revenue_goal")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q revenueGoalQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no revenueGoalQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from revenue_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for revenue_goal")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o RevenueGoalSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(revenueGoalBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), revenueGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"revenue_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, revenueGoalPrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from revenueGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for revenue_goal")
	}

	if len(revenueGoalAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *RevenueGoal) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindRevenueGoal(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *RevenueGoalSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := RevenueGoalSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), revenueGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"revenue_goal\".* FROM \"revenue_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, revenueGoalPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in RevenueGoalSlice")
	}

	*o = slice

	return nil
}

// RevenueGoalExists checks if the RevenueGoal row exists.
func RevenueGoalExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"revenue_goal\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if revenue_goal exists")
	}

	return exists, nil
}

// Exists checks if the RevenueGoal row exists.
func (o *RevenueGoal) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return RevenueGoalExists(ctx, exec, o.ID)
}
